import QtQuick 2.4
import Ubuntu.Components 1.3
import Ubuntu.Components.ListItems 1.3 as ListItem

Page {
    title: i18n.tr("About")
    Column {
        anchors.centerIn: parent
        spacing: units.gu(4)

        UbuntuShape {
            id: logo

            radius: "medium"

            width: units.gu(15)
            height: width

            source: Image {
                source: "../ftpmanager.png"
            }

            anchors.horizontalCenter: parent.horizontalCenter
        }

        Column {
            width: parent.width

            Label {
                fontSize: "x-large"
                font.weight: Font.DemiBold
                text: "uFTP"

                anchors.horizontalCenter: parent.horizontalCenter
            }

            Label {
                text: i18n.tr("Version ") + "0.1.67"

                anchors.horizontalCenter: parent.horizontalCenter
            }
        }

        Column {
            width: parent.width

            Label {
                text: "(C) 2015-2016 Davide Costa"
                anchors.horizontalCenter: parent.horizontalCenter
            }

            Label {
                fontSize: "small"
                text: i18n.tr("Released under the terms of the GNU GPL v3")

                anchors.horizontalCenter: parent.horizontalCenter
            }
        }

        Column {
            width: parent.width
            visible: false

            Button {
                text: i18n.tr("Contributors")

                anchors.horizontalCenter: parent.horizontalCenter
                onClicked: pageStack.push(contributors)
            }
        }

        Column {
            width: parent.width
            spacing: units.gu(2)

            Label {
                fontSize: "small"
                text: i18n.tr("Source code available on ") + "<a href=\"https://launchpad.net/uftp/\">launchpad.net</a>"

                anchors.horizontalCenter: parent.horizontalCenter

                onLinkActivated: Qt.openUrlExternally(link)
            }
        }

    }
    Component{
        id: contributors
        Page{
            title: i18n.tr("Contributors")
            Column {
                anchors.fill: parent

                ListItem.Header {
                    text: i18n.tr("A big thanks to:")
                }

                ListItem.Subtitled {
                    text: ""
                    subText: ""
                }
            }
        }
    }
}
