/*
 * Copyright 2014-2016 Canonical Ltd.
 *
 * This file is part of webbrowser-app.
 *
 * webbrowser-app is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * webbrowser-app is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import QtQuick 2.4
import Ubuntu.Components 1.3
import Ubuntu.Components.Popups 1.3
import Ubuntu.Content 1.3

Component {
    PopupBase{
        id: rootItem

        parent: QuickUtils.rootItem(this)

        Rectangle {
            anchors.fill: parent
            id: picker

            ContentPeerPicker {
                visible: parent.visible

                contentType: ContentType.All
                handler: ContentHandler.Source

                onPeerSelected: {
                    peer.selectionType = ContentTransfer.Multiple
                    explorePage.activeTransfer = peer.request(appStore);
                }

                onCancelPressed: {
                    rootItem.hide()
                }
            }
            ContentTransferHint {
                id: transferHint
                anchors.fill: parent
                activeTransfer: explorePage.activeTransfer
            }

            ContentStore {
                id: appStore
                scope: ContentScope.App
            }

            Connections {
                target: explorePage.activeTransfer ? explorePage.activeTransfer : null
                onStateChanged: {
                    if (explorePage.activeTransfer.state === ContentTransfer.Charged) {
                        for (var i=0; i<explorePage.activeTransfer.items.length; i++) {
                            console.log("CONTENT IMPORTED:", explorePage.activeTransfer.items[i].url.toString().replace("file://", ""))
                        }
                        up.show()
                        up.title = i18n.tr("Upload") + " " + i + " " + i18n.tr("file?")
                        rootItem.hide()
                    }
                }
            }
        }

    }
}
