import os
import paramiko
import stat
import posixpath
import pyotherside

class utils:
    def connect(self, address, port, user, pwd, pka=False):
        self.address = address
        self.user = user
        self.pwd = pwd
        self.error = 0
        try:
            if port == '':
                port = 22
            else:
                try:
                    port = int(port)
                except:
                    port = 22
            self.port = port
            self.sftp_transport = paramiko.Transport((address, int(port)))
            if pka  == True and pwd == "":
                k = paramiko.RSAKey.from_private_key_file(os.path.expanduser('~/.config/ftpmanager.costa/id_rsa'))
                self.sftp_transport.connect(username=user, pkey=k)
            else:
                self.sftp_transport.connect(username=user, password=pwd)
            self.sftp = paramiko.SFTPClient.from_transport(self.sftp_transport)
            paramiko.channel.Channel.settimeout(self,5)
            self.sftp.chdir('/')
        except Exception as e:
            self.error = e

    def list(self):
        if(self.error == 0):
            listobj = []
            try:
                for attr in self.sftp.listdir_attr():
                    if stat.S_ISDIR(attr.st_mode):
                        listobj.append({ 'name': attr.filename, 'type': str('folder'), 'size': str('FOLDER') })
                    else:
                        listobj.append({ 'name': attr.filename, 'type': str('empty'), 'size': str(self.sftp.stat(attr.filename).st_size) })
                return sorted(listobj, key=lambda k: k['name'])
            except:
                return str('connerror')
        else:
              return [ { 'name': str(self.error), 'type': 'error', 'size': str('none') } ]

    def chdir(self, dir):
        try:
            return self.sftp.chdir(dir)
        except Exception as e:
            return str('error')

    def download(self, name, path, size, qobj):
        def callback(transferred, toBeTransferred):
            try:
                perc = int((transferred) / toBeTransferred * 100)
                if perc > 100:
                    qobj.x = 100
                else:
                    qobj.x = perc
            except:
                return None
        try:
            paramiko.channel.Channel.settimeout(self,500)
            self.sftp.get(path + '/' + name, os.path.expanduser('~/.local/share/ftpmanager.costa/' + name), callback=callback)
            paramiko.channel.Channel.settimeout(self,5)
        except:
            return str('error')

    def upload(self, name, path, qobj):
        def callback(transferred, toBeTransferred):
            try:
                perc = int((transferred) / toBeTransferred * 100)
                if perc > 100:
                    qobj.x = 100
                else:
                    qobj.x = perc
            except:
                return None
        try:
            paramiko.channel.Channel.settimeout(self,500)
            qobj.n = 0
            for items in name:
                size = os.path.getsize(items)
                self.sftp.put(items, items.rsplit('/',1)[1], callback=callback)
                qobj.n = qobj.n + 1
            paramiko.channel.Channel.settimeout(self,5)
            return None
        except:
            return str('error')

    def newdir(self, name):
        try:
            self.sftp.mkdir(name)
        except:
            return str('error')

    def deletefile(self, name):
        try:
            self.sftp.remove(name)
        except:
            return str('error')

    def deletedir(self, start, current, ent=0, ex=0):
        try:
            for f in self.sftp.listdir_attr(start):
                rpath = posixpath.join(start, f.filename)
                if stat.S_ISDIR(f.st_mode):
                    self.deletedir(rpath, rpath)
                else:
                    rpath = posixpath.join(start, f.filename)
                    self.sftp.remove(rpath)
            self.sftp.rmdir(start)
        except:
            return str('error')
        
    def rename(self, start, end):
        try:
            self.sftp.rename(start, end)
        except:
            return str('error')

    def opentext(self, name):
        try:
            paramiko.channel.Channel.settimeout(self,10)
            data = ''
            resp = self.sftp.open(self.path() + '/' + name)
            for line in resp:
                data = data + line
            paramiko.channel.Channel.settimeout(self,5)
            return data
        except:
            return str('error')

    def savetext(self, name, content):
        try:
            paramiko.channel.Channel.settimeout(self,10)
            file = self.sftp.file(name, 'w')
            file.write(content)
            file.flush()
            paramiko.channel.Channel.settimeout(self,5)
            return None
        except:
            return str('error')

    def path(self):
        try:
            return str(self.sftp.getcwd())
        except:
            return str('*error')

    def exit(self):
        if(self.error == 0):
            try:
                self.sftp.close()
                return None
            except:
                return None

utils = utils()
